<?php
	function srclubplugins_page_header(){?>
		<p>
			<a href="https://srmehranclub.com/" target="_blank">
				<img src="<?php echo plugin_dir_url( __FILE__ );?>/logo.png">
			</a>
		</p>
	<?php }

	function srclubplugins_page_footer(){?>
		<p style="text-align:right;margin-right:10px;">
			<a href="https://srmehranclub.com/" target="_blank">Created by Srmehranclub.com</a>
		</p>
	<?php }

	function srclubplugins_page_settings(){
		srclubplugins_page_header();

		if(!empty($_POST['srclubplugins'])){
			$data = array_map('trim', $_POST['srclubplugins']);
			SrpluginsHelper::setCredentials($data['key'], $data['secret']);
		}

		$data = SrpluginsHelper::getCredentials();

		$paths = array(
			'backup' => SrpluginsHelper::getBackupDirectory(),
			'download' => SrpluginsHelper::getDownloadDirectory()
		);

		$sizes = array(
			'backup' => SrpluginsHelper::getDirectorySize($paths['backup']),
			'download' => SrpluginsHelper::getDirectorySize($paths['download'])
		);
	?>
		
		<div class="wrap">
			<h1 class="wp-heading-inline">Srmehranclub.com plugins</h1>
			<form method="post" action="<?php echo $_SERVER['REQUEST_URI']?>">
				<table class="srclubplugins-table-settings">
					<tr>
						<th>Key:</th>
						<td><input type="text" name="srclubplugins[key]" value="<?php echo $data['key'];?>"></td>
					</tr>
					<tr>
						<th>Secret:</th>
						<td><input type="text" name="srclubplugins[secret]" value="<?php echo $data['secret'];?>"></td>
					</tr>
					<tr></tr>
					<tr>
						<th>Backups Folder:</th>
						<td><?php echo SrpluginsHelper::getBackupDirectory();?> - (<?php echo $sizes['backup'];?>)</td>
					</tr>
					<tr>
						<th>Downloads Folder:</th>
						<td><?php echo SrpluginsHelper::getDownloadDirectory();?> - (<?php echo $sizes['download'];?>)</td>
					</tr>
				</table>
				<input type="submit" name="submit" id="submit" class="button button-primary button-large" value="Save Changes">
			</form>
		</div>


	<?php srclubplugins_page_footer(); } 

	function srclubplugins_page_plugins(){
		srclubplugins_page_header();
		if(!empty($_REQUEST['download-id'])){
			srclubplugins_page_plugins_download();
		} elseif(!empty($_REQUEST['install-id'])){
			srclubplugins_page_plugins_install();
		} elseif(!empty($_REQUEST['reinstall-id'])){
			srclubplugins_page_plugins_reinstall();
		} else {
			srclubplugins_page_plugins_list();
		}

		srclubplugins_page_footer();
	}

	function srclubplugins_page_plugins_install(){
		global $wpdb;
		$productId = (int)trim($_REQUEST['install-id']);


		if(!empty($productId) && ($ret = $wpdb->get_row('SELECT * FROM `'.$wpdb->prefix.'srclubplugins_history` WHERE `action`="download" AND id="'.$productId.'"', ARRAY_A))){
			$isPlugin = ($ret['type'] == 'plugin');
			$dir = SrpluginsHelper::getDownloadDirectory();
			$pluginRootDir = get_home_path().'wp-content/'.(($isPlugin) ? 'plugins' : 'themes').'/';
			echo '<br><br><div>';
			echo "<p>Create temp folder...<br></p>";
			mkdir($dir.'temp/');

			echo "<p>Extract from archive ".(($isPlugin) ? 'plugin' : 'theme')."...<br></p>";
			$zip = new ZipArchive; 
			$zip->open($ret['path']); 
			$zip->extractTo($dir.'temp/'); 
			$zip->close();
			$pluginDirectory = @reset(array_diff(scandir($dir.'temp/'), array('.', '..')));
			echo "<p>Move folder `$pluginDirectory`...<br></p>";

			if(file_exists($pluginRootDir.$pluginDirectory)){
				echo "<p>Сreate a backup copy of the previously installed ".(($isPlugin) ? 'plugin' : 'theme')."...<br></p>";
				$backupFilename = $pluginDirectory.'-'.date('Y-m-d-His').'.zip';
				$dirBackup = SrpluginsHelper::getBackupDirectory();
				SrpluginsHelper::zip($pluginRootDir.$pluginDirectory, $dirBackup.$backupFilename);
				$installedProduct = SrpluginsHelper::getInstalledProductByName($ret['product_name'], $ret['type']);
				$history = array(
					'type' => $ret['type'],
					'action' => 'backup',
					'version' => $installedProduct['Version'],
					'date' => date('Y-m-d H:i:s'),
					'path' => $dirBackup.$backupFilename,
					'product_name' => $ret['product_name']
				);
				$wpdb->insert($wpdb->prefix.'srclubplugins_history', $history);
			}

if(!empty($pluginDirectory))
			SrpluginsHelper::rcopy($dir.'temp/'.$pluginDirectory, $pluginRootDir.$pluginDirectory);
else
echo "Tried to erase plugin folder !";

			echo "<p>Clear temp folder...<br></p>";
			SrpluginsHelper::rrmdir($dir.'temp/');
			echo "<p>".(($isPlugin) ? 'Plugin' : 'Theme')." installed!<br></p>";
			echo '</div>';
		}
	}

	function srclubplugins_page_plugins_reinstall(){
		global $wpdb;
		$productId = (int)trim($_REQUEST['reinstall-id']);

		if(!empty($productId) && ($ret = $wpdb->get_row('SELECT * FROM `'.$wpdb->prefix.'srclubplugins_history` WHERE `action`="download" AND id="'.$productId.'"', ARRAY_A))){
			$isPlugin = ($ret['type'] == 'plugin');
			$dir = SrpluginsHelper::getDownloadDirectory();


			$pluginRootDir = get_home_path().'wp-content/'.(($isPlugin) ? 'plugins' : 'themes').'/';
			echo '<br><br><div>';
			echo "<p>Create temp folder...<br></p>";
			mkdir($dir.'temp/');

			echo "<p>Extract from archive ".(($isPlugin) ? 'plugin' : 'theme')."...<br></p>";
			$zip = new ZipArchive; 
			$zip->open($ret['path']); 
			$zip->extractTo($dir.'temp/'); 
			$zip->close();
			$pluginDirectory = @reset(array_diff(scandir($dir.'temp/'), array('.', '..')));
			echo "<p>Move folder `$pluginDirectory`...<br></p>";

			if(file_exists($pluginRootDir.$pluginDirectory)){
				echo "<p>Сreate a backup copy of the previously installed ".(($isPlugin) ? 'plugin' : 'theme')."...<br></p>";
				$backupFilename = $pluginDirectory.'-'.date('Y-m-d-His').'.zip';
				$dirBackup = SrpluginsHelper::getBackupDirectory();
				SrpluginsHelper::zip($pluginRootDir.$pluginDirectory, $dirBackup.$backupFilename);
				$installedProduct = SrpluginsHelper::getInstalledProductByName($ret['product_name'], $ret['type']);
				$history = array(
					'type' => $ret['type'],
					'action' => 'backup',
					'version' => $installedProduct['Version'],
					'date' => date('Y-m-d H:i:s'),
					'path' => $dirBackup.$backupFilename,
					'product_name' => $ret['product_name']
				);
				$wpdb->insert($wpdb->prefix.'srclubplugins_history', $history);
			}

if(!empty($pluginDirectory))
			SrpluginsHelper::rcopy($dir.'temp/'.$pluginDirectory, $pluginRootDir.$pluginDirectory);

else
echo "Tried to erase $pluginRootDir !!";

			echo "<p>Clear temp folder...<br></p>";
			SrpluginsHelper::rrmdir($dir.'temp/');
			echo "<p>".(($isPlugin) ? 'Plugin' : 'Theme')." reinstalled!<br></p>";
			echo '</div>';
		}
	}

	function srclubplugins_page_plugins_download(){
		$productId = (int)trim($_REQUEST['download-id']);

		if(!empty($productId)){
			if(($ret = SrpluginsHelper::getProduct($productId)) && $ret['status'] == 'success'){
				$filepath = SrpluginsHelper::getDownloadDirectory() . $ret['data']['basename'];
				$result = SrpluginsHelper::downloadProduct($productId, $filepath);

				if($result){
					global $wpdb;
					$history = array(
						'type' => $ret['data']['type'],
						'action' => 'download',
						'version' => $ret['data']['version'],
						'date' => date('Y-m-d H:i:s'),
						'path' => $filepath,
						'product_name' => $ret['data']['product_name']
					);
					$wpdb->insert($wpdb->prefix.'srclubplugins_history', $history);
					echo '<p>Product downloaded</p>';
				} else {
					echo '<p>Unknown error</p>';
				}
			}
		}
	}

	function srclubplugins_page_plugins_list(){
		global $wpdb;
		$meta = SrpluginsHelper::getMeta();
		$meta = $meta['data'];
		?>
		<h1>SrmehranClub Plugins Manager</h1>
		<div>
			<input  class="srclubplugins-form-search-input" type="text" placeholder="Search">
			<button class="srclubplugins-form-search-submit">Search</button>
			<button class="srclubplugins-form-search-clear">Clear</button>
		</div>
		<?php

		$products = SrpluginsHelper::getProducts();
		$downloads = array();

		if($ret = $wpdb->get_results('SELECT * FROM `'.$wpdb->prefix.'srclubplugins_history` WHERE `action`="download"', ARRAY_A)){
			foreach($ret as $d){
				$downloads[$d['product_name']] = array('version' => $d['version'], 'id' => $d['id']);
			}
		}

		if($products['status'] == 'success'){?>
		<table class="wp-list-table widefat plugins">
			<thead>
				<tr>
					<th scope="col" id="name" class="manage-column column-name column-primary">Plugin</th>
					<th scope="col" id="description" class="manage-column">Installed</th>
					<th scope="col" id="description" class="manage-column">Downloaded</th>
					<th scope="col" id="description" class="manage-column">Last</th>
					<th scope="col" id="description" class="manage-column">Active</th>
					<th scope="col" id="description" class="manage-column">Size</th>
					<th scope="col" id="description" class="manage-column">Options</th>
				</tr>
			</thead>
			<tbody id="the-list">
			<?php foreach($products['data'] as $product){
				$isDownloaded = array_key_exists($product['product_name'], $downloads);
				$isInstalled = false;
			?>
			<tr>
				<td class="plugin-title column-primary">
					<div><b><?php echo $product['product_name'];?></b></div>
					<?php if($meta['allow_downloads'] !== -1){?>
						<div>Available Downloads: <?php echo $meta['allow_downloads'];?></div>
					<?php }?>
				</td>
				<td class="">
					<div>
					<?php
					$p = SrpluginsHelper::getInstalledProductByName($product['product_name'], $product['type']);
					if($p){
						echo $p['Version'];
						$isInstalled = true;
					}
					?>
					</div>
				</td>
				<td class="">
					<div>
					<?php if($isDownloaded){?>
						<?php echo $downloads[$product['product_name']]['version'];?>
					<?php }?>
					</div>
				</td>
				<td class="">
					<div><?php echo $product['version'];?></div>
				</td>
				<td class="">
					<div>
						<?php if($isInstalled && (($product['type'] == 'plugin' && is_plugin_active($p['file'])) || ($product['type'] == 'theme' && get_template() == $p->get('TextDomain')))){?>
							<div alt="f147" class="dashicons dashicons-yes green" title="On"></div>
						<?php } else {?>
							<div alt="f460" class="dashicons dashicons-minus" title="Unknown"></div>
						<?php } ?>
					</div>
				</td>
				<td class="">
					<div><?php echo SrpluginsHelper::formatSize($product['product_size']);?></div>
				</td>

				<td class="">
					<div>
						<span class="download">
							<?php if($isDownloaded && !$isInstalled){?>
							<a class="download" href="<?php echo $_SERVER['REQUEST_URI']?>&install-id=<?php echo $downloads[$product['product_name']]['id'];?>">Install</a>
<a class="download" href="<?php echo $_SERVER['REQUEST_URI']?>&download-id=<?php echo $downloads[$product['product_name']]['id'];?>">Re-Download</a>

							<?php } elseif($isDownloaded && $isInstalled){?>
							<a class="download" href="<?php echo $_SERVER['REQUEST_URI']?>&reinstall-id=<?php echo $downloads[$product['product_name']]['id'];?>">Reinstall</a>
							<?php } elseif($meta['allow_downloads'] !== 0) {?>
							<a class="download" href="<?php echo $_SERVER['REQUEST_URI']?>&download-id=<?php echo $product['id'];?>">Download</a>
							<?php } ?>
						</span>
					</div>
				</td>

			</tr>
			<?php } ?>
			</tbody>
		</table><br>
		<button class="srclubplugins-refresh button button-primary button-large" name="refresh">Refresh list</button>
		<?php } 
	}

	function srclubplugins_page_files(){
		srclubplugins_page_header();
		global $wpdb;

		if(!empty($_POST['delete_id'])){
			$id = (int)$_POST['delete_id'];
			if($ret = $wpdb->get_row('SELECT * FROM '.$wpdb->prefix.'srclubplugins_history WHERE `id`="'.$id.'"')){
				$wpdb->delete($wpdb->prefix.'srclubplugins_history', array('id' => $id));
				@unlink($ret['path']);
			}
		}

		$downloads = $wpdb->get_results('SELECT * FROM `'.$wpdb->prefix.'srclubplugins_history` WHERE `action`="download"', ARRAY_A);

		$backups = $wpdb->get_results('SELECT * FROM `'.$wpdb->prefix.'srclubplugins_history` WHERE `action`="backup"', ARRAY_A);
		?>
		<h1>Downloads</h1>
		<table class="wp-list-table widefat plugins">
			<thead>
				<tr>
					<th scope="col" id="name" class="manage-column column-name column-primary">Plugin</th>
					<th scope="col" id="description" class="manage-column">Date</th>
					<th scope="col" id="description" class="manage-column">Version</th>
					<th scope="col" id="description" class="manage-column">Size</th>
					<th scope="col" id="description" class="manage-column"></th>
				</tr>
			</thead>
			<tbody id="the-list">
			<?php foreach($downloads as $d){?>
			<tr>
				<td class="plugin-title column-primary">
					<div><b><?php echo $d['product_name'];?></b></div>
				</td>
				<td class="">
					<div>
					<?php echo $d['date'];?>
					</div>
				</td>
				<td class="">
					<div><?php echo $d['version'];?></div>
				</td>
				<td class="">
					<div><?php echo SrpluginsHelper::formatSize(filesize($d['path']));?></div>
				</td>
				<td class="">
					<div>
						<span class="download">
							<a class="download" href="<?php echo SrpluginsHelper::getDownloadUrl().basename($d['path']);?>">Download</a>
							|
							<a class="history-remove" data-id="<?php echo $d['id'];?>">Remove</a>
						</span>
					</div>
				</td>

			</tr>
			<?php } ?>
			</tbody>
		</table>
		<h1>Backups</h1>
		<table class="wp-list-table widefat plugins">
			<thead>
				<tr>
					<th scope="col" id="name" class="manage-column column-name column-primary">Plugin</th>
					<th scope="col" id="description" class="manage-column">Date</th>
					<th scope="col" id="description" class="manage-column">Version</th>
					<th scope="col" id="description" class="manage-column">Size</th>
					<th scope="col" id="description" class="manage-column"></th>
				</tr>
			</thead>
			<tbody id="the-list">
			<?php foreach($backups as $d){?>
			<tr>
				<td class="plugin-title column-primary">
					<div><b><?php echo $d['product_name'];?></b></div>
				</td>
				<td class="">
					<div>
					<?php echo $d['date'];?>
					</div>
				</td>
				<td class="">
					<div><?php echo $d['version'];?></div>
				</td>
				<td class="">
					<div><?php echo SrpluginsHelper::formatSize(filesize($d['path']));?></div>
				</td>
				<td class="">
					<div>
						<span class="download">
							<a class="download" href="<?php echo SrpluginsHelper::getBackupUrl().basename($d['path']);?>">Download</a>
							|
							<a class="history-remove" data-id="<?php echo $d['id'];?>">Remove</a>
						</span>
					</div>
				</td>

			</tr>
			<?php } ?>
			</tbody>
		</table>
	<?php srclubplugins_page_footer();} ?>